// Showing the news on the widget
var ticker = 'front';
var reload = 10;
var month_numbers = new Array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
var currentlyBeingSpoken = null;
var speech_news = null;
var print_news = null;
var printDef = false;
var nbrItems = null;


function hidetag(txt){
	txt = unescape(txt);
	txt = txt.replace(/<([^>])*>/g,'');
	return txt;
}

function hidequote(txt){
	txt = txt.replace(/'/g,'’');
	txt = txt.replace(/"/g,'‘‘');
	return txt;	
}

function Go(name){
	journal = name;
	getRSS(name);
}

function setLastUpdate(){
	var dd = new Date;
	var dayOfMonth = dd.getDate();
	if (dayOfMonth < 10){
		dayOfMonth = '0' + dayOfMonth;
	}
	var hours = dd.getHours();
	if (hours < 10){
		hours = '0' + hours;
	}
	var minutes = dd.getMinutes();
	if (minutes < 10){
		minutes = '0' + minutes;
	}
	if(journal == "ticker"){
		updateDisplayText = ' ' +dayOfMonth+'/' + month_numbers[dd.getMonth()] + '/' +dd.getFullYear()+ ' ' + hours + ':' + minutes;;
		date = updateDisplayText;
	}
	else{
		updateDisplayText = dayOfMonth + ' ' + month_names[dd.getMonth()] + ' ' + dd.getFullYear() + ' ' + hours + ':' + minutes;
	}
	$('lastUpdate_' + journal).innerHTML = updateDisplayText;
	$('lastUpdate_' + journal).setAttribute('onclick','event.stopPropagation();Go(\''+journal+'\')');
	
}

function setUpdatingText(Message){
	if($('actualCateg_' + journal)){
		if(journal == "ticker"){
			feedName = tickerDefault.nom;
		}
		else{
			feedName = $('feedURL_'+journal).options[$('feedURL_'+journal).selectedIndex].text;
		}
		$('actualCateg_' + journal).innerHTML = feedName;
	}
	$('lastUpdate_' + journal).innerHTML = Message;
	$('lastUpdate_' + journal).setAttribute('onclick','event.stopPropagation();Go(\''+journal+'\');');
}

function clicked (section) { 
	if (window.widget){
		widget.openURL(section);
	}
	else{
		document.location = section;
	}
}
function setSkin(args) {
	$('formuSkin').innerHTML = $('skin_form').options[$('skin_form').selectedIndex].firstChild.data;
	$('Front_top').style.backgroundImage = 'url("Images/Front/'+args+'/Front_top.png")';
	$('Front_bot').style.backgroundImage = 'url("Images/Front/'+args+'/Front_bot.png")';
	$('back').style.backgroundImage = 'url("Images/Back/Back_'+args+'.png")';
	document.styleSheets[0].cssRules[8].style.backgroundImage = 'url("Images/Newspaper/Journal_'+args+'.png")';
	if(window.widget){
		widget.setPreferenceForKey(args,"skin");
	}
}

function savepreferences(save,valeur){
	if(save == "voice"){
		if(window.widget) {
			if( currentlyBeingSpoken != null) {
				currentlyBeingSpoken.cancel();
			}	
			widget.setPreferenceForKey(valeur,"Voice");
			currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + valeur + "\" using \"" + valeur + "\"'" , doneSpeaking);	
		}
		$('formuVoice').innerHTML = $('speacher').value;
	}
}
function toggle(arg) {
	mydiv = 'toogled_'+journal+ arg ;
	if ($(mydiv).style.display == 'block') {
		fade(mydiv,'out','4');
	}
	else {
		$(mydiv).style.display = 'block';
		fade(mydiv,'in','4');
	}
	ScrollArea.refresh();
}

function showRSS(journal,RSS){
	// NewsTicker Part
	if (journal == "ticker"){
		item_ticker = "";
		for (var i=0; i<RSS.items.length; i++){
			item_ticker += (RSS.items[i].title == null) ? "" : "<a href=\"#\" onClick=\"event.stopPropagation();clicked(\'http://www.iactu.net/read.php?sym=" +tickerDefault.symbol+"&url=" +escape(RSS.items[i].link) + "\');\"')\">" + RSS.items[i].title + " --- </a>";
		}
		if(document.getElementById('tickerE').checked){
			NewsTicker();
			$('NewsTicker').innerHTML = item_ticker;
		}
		setLastUpdate();
	}
	// NewsPapers Part
	else{
		feedItem = "";
		speech_news = '';
		print_news = "";
		print_news += "-e 'make new paragraph at end with data \""+ hidequote($('logo_'+journal).innerText) + "\" with properties {size:20, color:{0, 0, 0}, font:\"Gill Sans\"}' ";
		print_news += "-e 'make new paragraph at end with data \" - "+ hidequote($('actualCateg_'+journal).innerText) +"\n\" with properties {size:16, color:{0, 0, 0}, font:\"Gill Sans Light\"}' ";
		nbrItems = RSS.items.length;
		for (var i=0; i<RSS.items.length; i++){
			rss_title = RSS.items[i]['title'];
			rss_description = RSS.items[i]['description'];
			rss_pubdate = RSS.items[i]['pubDate'];
			rss_link = RSS.items[i]['link'];
			
	 		toogle_Title = '<div class="title" onclick="toggle(\''+i+'\');" id="title_'+journal+i+'" style="font-size:11px">' + hidetag(rss_title)  + '</div>';

			toogle_Cont = '<div id="toogled_'+journal+i+'" style="display:none;opacity:0;" >';
			toogle_Cont += '<span class="date" id="date_'+journal+i+'" style="font-size:10px">'+rss_pubdate+'</span><br>';
			toogle_Cont += '<span class="description" id="description_'+journal+i+'" style="font-size:10px">'+rss_description+'</span><br>';
			toogle_Cont += '<span class="link" id="link_'+journal+i+'" style="font-size:10px"><a href="#" onClick="clicked(\'http://www.iactu.net/read.php?sym=' +allTheData[((journal.substr(2,3))-1)].symbol+'&url=' +escape(rss_link) + '\');">'+getLocalizedString('read')+' >></a></span>';
			toogle_Cont += '</div>';
			
			speech_news += hidequote(hidetag(rss_title)) +".\n" ;
		//	speech_news += hidequote(rss_pubdate) +".\n" ;
			speech_news += hidequote(hidetag(rss_description)) +".\n" ;			
			
			print_news += "-e 'make new paragraph at end with data \"\n"+ hidequote(rss_title) + "\" with properties {size:14, color:{0, 0, 0}, font:\"Arial Black\"}' ";
			print_news += "-e 'make new paragraph at end with data \"\n"+ hidequote(rss_pubdate) + "\" with properties {size:12, color:{30350, 30350, 30350}, font:\"Gill Sans Light\"}' ";
			print_news += "-e 'make new paragraph at end with data \"\n"+ hidequote(hidetag(rss_description)) + "\" with properties {size:13, color:{0, 0, 0}, font:\"Gill Sans\"}' ";
		//	print_news += "-e 'make new paragraph at end with data \"\n"+ rss_link +"\n" + "\" with properties {size:12, color:{0, 0, 30350}, font:\"Arial\"}' ";
			
			feedItem += "<div class='feeditem'>" + toogle_Title + toogle_Cont + "</div>";
		}
		$('feedcontaineer_' + journal).innerHTML = feedItem;
		window.resizeTo('281','254');
		ScrollArea.refresh();
		setLastUpdate();
	}
	return true;
}
function checkSave(val){
	if(val == "on"){
		sv = "on";
	}
	else{
		sv = "off"
	}
	widget.setPreferenceForKey(sv,"tickerE");
}
function update(){
	url='http://widget.widgetinfo.net/update/index.php?p=iActu';
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("GET",url,true);
	xmlhttp.onreadystatechange=function() {
		if(xmlhttp.readyState==4) {
			if(xmlhttp.responseText > 2.2){
				$('alert_txt').innerHTML = getLocalizedString('newversion');
				btn_download = new AppleGlassButton($('btn_right'),getLocalizedString('download'),function(){
					clicked('http://www.widgetinfo.net/iActu/?ref=update');
					fade('alertDiv','out','5');
				});
				btn_later = new AppleGlassButton($('btn_left'),getLocalizedString('later'),function(){
					fade('alertDiv','out','5');
				});
				fade("alertDiv","in","5")
				bl('block');
			}
		}
	}
	xmlhttp.send(null);
}

//////////////////// SPEAKING ///////////////
function speech(theTxt){
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
		}
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + theTxt + "\" using \" Victoria \"'" , done);	
	}
}


function speak(){
	var textToSpeak = speech_news;
	var regExForSingleQuote = new RegExp ('\'', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForSingleQuote, '`') ;
	var regExForDoubleQuote = new RegExp ('"', 'g') ;
	var textToSpeak = textToSpeak.replace(regExForDoubleQuote, '') ;

	var chosenVoice = $('speacher').value;

	document.getElementById("speech_"+journal).innerHTML = "<img src=\"images/Newspaper/btn_speakoff.png\" onclick=\"StopSpeech()\" name=\"stop\"/>";
	
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
		}
		// Pause iTunes if it played
		pauseiTunes_script = "/usr/bin/osascript -e 'tell application \"System Events\"' -e ' if process \"iTunes\" exists then ' -e ' tell application\"iTunes\"' -e 'if player state is playing then' -e 'pause'  -e 'end if' -e 'end tell' -e' end if ' -e ' end tell'";
		pauseiTunes = widget.system(pauseiTunes_script, null);
		// Speak the news
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + textToSpeak + "\" using \"" + chosenVoice + "\"'" , done);	
	}
}

function StopSpeech(event){
	if(window.widget) {
		currentlyBeingSpoken.cancel();
	}
	done();
}


function done(){
	document.getElementById("speech_"+journal).innerHTML = "<img src=\"images/Newspaper/btn_speakon.png\" onclick=\"speak()\"/>";
	doneSpeaking();
}

function doneSpeaking(){
	currentlyBeingSpoken = null;
}

function removed(){
	if(currentlyBeingSpoken != null) {
		StopSpeech();
	}
}

if(window.widget){
	widget.onremove = removed;
}
/// PRINTNG ////
function printNews(){
	var printdoc = "/usr/bin/osascript " +
	"-e 'tell application \"TextEdit\" ' " + 
	"-e 'activate' " +
	"-e 'make new document' " +
	"-e 'tell front document' " +
	hidetag(print_news) +
	"-e 'end tell' " +
	"-e 'end tell' ";
	alert(print_news);
	widget.system(printdoc, null);	
}

function printNP(np){
	printDef = true;
	Go(np);
}
/// ZOOM UP/DOWN ///
function ZoomUp(){
	for(var x = 0 ; x < nbrItems ; x++){
		var title = parseInt($("title_"+journal+x).style.fontSize) + 1;
		$("title_"+journal+x).style.fontSize= title +"px";
		
		var theDate = parseInt($("date_"+journal+x).style.fontSize) + 1;
		$("date_"+journal+x).style.fontSize= theDate +"px";
		
		var description = parseInt($("description_"+journal+x).style.fontSize) + 1;
		$("description_"+journal+x).style.fontSize= description +"px";
		
		var theLink = parseInt($("link_"+journal+x).style.fontSize) + 1;
		$("link_"+journal+x).style.fontSize= theLink +"px";
	}
	ScrollArea.refresh();
	
}
function ZoomDown(){
	for(var x = 0 ; x < nbrItems ; x++){
		var title = parseInt($("title_"+journal+x).style.fontSize) - 1;
		$("title_"+journal+x).style.fontSize= title +"px";
		
		var theDate = parseInt($("date_"+journal+x).style.fontSize) - 1;
		$("date_"+journal+x).style.fontSize= theDate +"px";
		
		var description = parseInt($("description_"+journal+x).style.fontSize) - 1;
		$("description_"+journal+x).style.fontSize= description +"px";
		
		var theLink = parseInt($("link_"+journal+x).style.fontSize) - 1;
		$("link_"+journal+x).style.fontSize= theLink +"px";
	}
	ScrollArea.refresh();
}

