// Script manage animations and the comportement of the widget (inclluding switch between NP )

// Variables of Animations (include Scrolls)
var ScrollArea, ScrollBar; 
var frontResize;
var flipShown = false;
var fadeFlip = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// General Variables
var journal = 'ticker'; // Default part (front page)
var Buttons = "";
var NP = new Array("np1","np2","np3","np4","np5","np6");

var local = "fr_fr"; // Country

var creditsMsg = getLocalizedString('donate');

var inp = 0; // Setting kiosk counter

// Loading functions
function getLocalizedString(key){
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}
function $(element){
	return document.getElementById(element);
}

function setup(){ // onload actions
	if (window.widget){
		if(widget.preferenceForKey("skin")){
			setSkin(widget.preferenceForKey("skin"));
			$('skin_form').value = widget.preferenceForKey("skin");		
		}
		$('formuSkin').innerHTML = $('skin_form').options[$('skin_form').selectedIndex].firstChild.data;
	}	
	$('PreLoading').innerHTML = "<br><br>"+getLocalizedString('loading');
	$('front').style.display="block";
	$('back').style.display="none"; 
	frontResize = new Stretcher($('front'), 173, 1000 ,function(){
		if (frontResize.isStretched()) {
			fade('newspapers','in','5');
		}
		else if (!frontResize.isStretched()){
			$("newspapers").style.opacity = 0;
		}
	});
	if (!frontResize.isStretched()){
		frontResize.stretch(event);
	}
	restore_preferences(function(){
		restoreNP(function(){
			var c = allTheData.length;
			for (var i=0; i<c; ++i)
			{
				var data = allTheData[i];
				addsymbol (data.nom, data.country, data.symbol);
			}
			if($("row_"+tickerDefault.symbol)){
				$("row_"+tickerDefault.symbol).setAttribute("class", "row isticker");
			}
			$('labelSkin').innerHTML = getLocalizedString('skin');
			$('labelVoice').innerHTML = getLocalizedString('voice');
			$('credits').innerHTML = creditsMsg;
			btn_done = new AppleGlassButton($('btn_done'),getLocalizedString('done'),returnfromBack);
			btn_help = new AppleGlassButton($('btn_help'),'?',function(){clicked('http://www.widgetinfo.net/Support/?lang='+getLocalizedString('lang'))});
			setNP();
			setKiosk();
			Go('ticker');
			setTimeout('update();',500);

		});
	});
}

function restore_preferences(finit){ // Restore preferences
		var p_voice = widget.preferenceForKey("voice");
		if (p_voice){
			$('speacher').value = p_voice;		
		}
		else{
			var output = widget.system("/usr/bin/osascript -e 'set minor to system attribute \"sys2\"'", null).outputString;
			if(output>4){ // > 10.4
				$('speacher').value = "Alex";		
			}
			else{
				$('speacher').value = "Victoria";
				$('speacher').options[0].disabled = true;		
				
			}
		}
		if(widget.preferenceForKey("tickerE") != null){
			if(widget.preferenceForKey("tickerE") == "on"){
				document.getElementById('tickerE').checked = true;
			}
			else{
				document.getElementById('tickerE').checked = false;
			}
		}
		else{
			document.getElementById('tickerE').checked = true;
		}
		
		var tickerD = widget.preferenceForKey("tickerD");
		if (!tickerD){
			url='http://widget.widgetinfo.net/iActu/fetchDefault.php?k=t&l='+getLocalizedString('lang');
			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET",url,true);
			xmlhttp.onreadystatechange=function() {
				if(xmlhttp.readyState==4) {
					eval(xmlhttp.responseText);
					finit();
				}
			}
			
			xmlhttp.send(null);
		}
    	else{
			eval(tickerD);
			finit();
		}
	$('formuVoice').innerHTML = $('speacher').value;
	
	
}

function restoreNP(fini) { // Restore Newspapers
		var Newspapers = widget.preferenceForKey("newspapers");
		if (!Newspapers){
			// DETECT COUNTRY AND SET DEFAULT
			url='http://widget.widgetinfo.net/iActu/fetchDefault.php?k=np&l='+getLocalizedString('lang')+'&c='+local.replace(/[\n]/,'');
			xmlhttp=new XMLHttpRequest();
			xmlhttp.open("GET",url,true);
			xmlhttp.onreadystatechange=function() {
				if(xmlhttp.readyState==4) {
					eval(xmlhttp.responseText);
					fini();
				}
			}
			
			xmlhttp.send(null);
		}
    	else{
			allTheData = eval(Newspapers);
			fini();
		}
}
// Build Kiosk
function setKiosk(){
	kiosk = "";
	$('kiosk').innerHTML = kiosk;
	for(i=0;i<allTheData.length;i++){
		if(i<=2){multiplier = i;topmarg=0;}
		else if(i>2){multiplier = i-3;topmarg=90;}
		kiosk += "<img name=\"NP_"+NP[i]+"\" src=\"http://widget.widgetinfo.net/iActu/thumb/?id="+allTheData[i].symbol+"\" onClick=\"Zap('front','"+NP[i]+"');\"  oncontextmenu=\"prefsClicked('"+i+"',true);\" height=\"82px\" width=\"84px\" style=\"position:absolute;cursor:pointer;left:"+((82*multiplier)+15)+"px;top:"+topmarg+"px;\"/>";
	}
	$('kiosk').innerHTML = kiosk;
	refreshNP = window.setInterval(setKiosk,3600000); // Per Hour
}

// Zap between each newspaper
function Zap(debut,fin,kind){ 
	journal = fin; // IMPORTANT
	if(journal=='back'){
		$('back').style.height = '281px';
		window.resizeTo('281','254');
	}
	if (window.widget){
		if(!kind){trans="ToBack";}
		else{
			if(kind == "prev"){trans="ToFront";}
			else if(kind == "next"){trans="ToBack";}
		}
		widget.prepareForTransition(trans);
	} 
	$(debut).style.display = "none";
	$(fin).style.display = "block"; 
	if (window.widget){
		setTimeout('widget.performTransition();', 0);
	}
	if(journal=='back'){
		symbolBlur(event);
		setTimeout(function(){
			fade('backCtn','in',4);
		},500);
	}
	else{
		if(fin !='back' && fin!='front'){ // Remove Scroll Bar
			$("ScrollBar_"+fin).innerHTML = "";
			setup_newspaper();
		}
	}
}

function setup_newspaper() {
	ScrollBar = new AppleVerticalScrollbar($("ScrollBar_"+journal)); 
	ScrollArea = new AppleScrollArea($("parentDiv_"+journal)); 
	ScrollArea.addScrollbar(ScrollBar); 
	ScrollArea.refresh();
	window.resizeTo('281','254');
	$(journal).setAttribute('onmouseover','mousemove(\'buttons_'+journal+'\');');
	$(journal).setAttribute('onmouseout','mouseexit(\'buttons_'+journal+'\');');
	Go(journal);
}

function returnKiosk(debut) {
	if (window.widget){
	    widget.prepareForTransition("ToFront");
	}
	$(debut).style.display="none"; 
	$("front").style.display="block"; 
	if (!frontResize.isStretched()){
		$('newspapers').style.opacity = 0;
		frontResize.stretch(event);
	}
	if (window.widget){ 
	    setTimeout('widget.performTransition();', 0);
	}
	Go('ticker');
	$('fliprollie').style.display = 'none';
	if(changeInBack){
		setNP();
		setKiosk();
		Go('ticker');
	}
}

function returnfromBack(){
	symbolFocus(event);
	fade('backCtn','out',4);
	setTimeout(function(){
		returnKiosk('back');
	},500);
}

function NewsTicker(){
	ticker = document.createElement('marquee');
	ticker.id = "NT";
	ticker.setAttribute('scrollamount','3');
	ticker.setAttribute('onmouseover','this.stop()');
	ticker.setAttribute('onmouseout','this.start()');
	
	Source = document.createElement('span');
	Source.id = 'NewsTicker';
	Source.className = 'NewsTicker';
	
	ticker.appendChild(Source);
	
	$('NewsTickerContainer').appendChild(ticker);
}


// Show Loading 
function bl(type){ 
	$('Blank').style.display=type;
}
function Preload(kind){
	var div = "PreLoading";
	var timer = 4000 ;
	if(kind == "out")
		timer = 1000 ;
	if(kind == "in") { from = 0 ; dest = 0.7 ;$(div).style.display = 'block';}
	if(kind == "out") { from = 0.7 ; dest = 0 ;}
	elementFader = new AppleAnimator(timer, 13, from, dest, function(animation, now, first, done) {
		$(div).style.opacity = now;
		if (done) {
			if(kind == "out") {
				$(div).style.display = 'none';
			}
		}
	});
	elementFader.start();
}
// view Front Page
function viewFP(np){
    widget.openURL('http://widget.widgetinfo.net/iActu/viewFP.php?id='+allTheData[np].symbol);
}

function viewFPClick(args) {
	if(window.widget){
		menu = widget.createMenu();
	}
	menu.addMenuItem(getLocalizedString('viewFP'));
	menu.addMenuItem(getLocalizedString('subscribe'));
	menu.addSeparatorMenuItem();
	menu.addMenuItem(getLocalizedString('visitWebsite'));
	pos_y = 56;
	pos_x = 214;
	var selectedItem = menu.popup (pos_x, pos_y);
	if(selectedItem == 0){
		viewFP(args);
	}
	else if(selectedItem == 1){
	    clicked('http://widget.widgetinfo.net/iActu/subscribeNP.php?id='+allTheData[args].symbol);
	}
	else if(selectedItem == 3){
	    clicked(allTheData[args].link);
	}
}

/// Build Newspapers pages
function setNP() {
	inp = 0;
	Buttons = "";
	setButtons();
}
function setButtons(){
		var xhr = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (xhr) {
			bl('block');
			if(inp==0)
				Preload('in');
			inp1 = (inp + 1);
			xhr.open("GET", 'http://widget.widgetinfo.net/iActu/fetchRSS.php?sym='+allTheData[inp].symbol, true);
			xhr.overrideMimeType('text/html; charset=ISO-8859-1'); 
 			xhr.setRequestHeader("Cache-Control","no-cache");
    	    xhr.setRequestHeader("Pragma", "no-cache");
			xhr.onreadystatechange = function(){
 				if (xhr.readyState == 4){
					if (xhr.status == 200){
						Buttons+= '<div id="'+NP[inp]+'" class="journal">';
						Buttons+= '<div id="logo_'+NP[inp]+'" class="NP_name">'+allTheData[inp].nom+'</div>';
						Buttons+= '<div id="buttons_'+NP[inp]+'"><div class="return" onClick="returnKiosk(\''+NP[inp]+'\');"></div>';
						if(inp==0){
							Buttons+='<div id="previous"></div>';
						}else{
							Buttons+='<div id="previous"><img name="btn_previous" src="Images/Newspaper/btn_previous.png" onMouseDown="this.src=\'Images/Newspaper/btn_previous_p.png\'" onMouseup="this.src=\'Images/Newspaper/btn_previous.png\'" onClick="Zap(\''+NP[inp]+'\',\''+NP[inp-1]+'\',\'next\');" /></div>';
						}
						if(inp==(allTheData.length - 1)){
							Buttons+='<div id="next"></div>';
						} else{
							Buttons+='<div id="next"><img name="btn_next" src="Images/Newspaper/btn_next.png" onClick="Zap(\''+NP[inp]+'\',\''+NP[inp+1]+'\',\'prev\');" onMouseDown="this.src=\'Images/Newspaper/btn_next_p.png\'" onMouseup="this.src=\'Images/Newspaper/btn_next.png\'"/></div>';
						}
						Buttons+='<div id="speech_'+NP[inp]+'" class="speech"><img name="btn_speak" src="Images/Newspaper/btn_speakon.png" onclick="speak();"/></div>';
						Buttons+= '<div class="ZoomDown" onClick="ZoomDown();"/></div>';
						Buttons+= '<div class="ZoomUp" onClick="ZoomUp();" /></div>';
						Buttons+= '<div class="print" onClick="printNews();" /></div>';
						Buttons+= '<div class="viewFP" onClick="viewFPClick(\''+inp+'\');" /></div>';
						Buttons+= '</div>'
						Buttons+= '<div id="actualCateg_'+NP[inp]+'" class="actualCateg"></div>';
						Buttons+= '<div id="lastUpdate_'+NP[inp]+'" class="lastUpdate"></div>';
						Buttons+= '<div id="parentDiv_'+NP[inp]+'" class="parentDiv">';
						Buttons+= '<div id="feedcontaineer_'+NP[inp]+'" class="mainContent"></div></div>';
						Buttons+= '<div id="ScrollBar_'+NP[inp]+'" class="ScrollBar"></div>';
						Buttons+='<div class="configurationForm"><select name="feedURL_'+NP[inp]+'" id="feedURL_'+NP[inp]+'" onChange="Go(\''+NP[inp]+'\')" class="select_form">'+xhr.responseText+'</select></div>';
						Buttons+='</div>';
						if(inp == (allTheData.length - 1)){
							$('newspapers_all').innerHTML = Buttons;
							for(v=0;v<allTheData.length;v++){
								$(NP[v]).style.display="none";
							}
							Preload('out');
							bl('none');
						}
						else{
							inp++;
							setButtons();
						}
					}
				}
			}
			xhr.send(null);
  		}
}

/// Animation Fade/Show
function fade(div,kind,speed){
	var timer = (speed * 100) ;
	if(kind == "in") { from = 0 ; dest = 1 ;$(div).style.display = 'block';}
	if(kind == "out") { from = 1 ; dest = 0 ;}
	elementFader = new AppleAnimator(timer, 13, from, dest, function(animation, now, first, done) {
		$(div).style.opacity = now;
		if (done) {
			if(kind == "out") {
				$(div).style.display = 'none';
			}
		}
	});
	elementFader.start();
}

function mousemove(action){
    if (!flipShown)
    {
        if (fadeFlip.timer != null)
        {
            clearInterval (fadeFlip.timer);
            fadeFlip.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        fadeFlip.duration = 400;
        fadeFlip.starttime = starttime;
        fadeFlip.firstElement = $(action);
        fadeFlip.timer = setInterval ("animateFlip();", 13);
        fadeFlip.from = fadeFlip.now;
        fadeFlip.to = 1.0;
        animateFlip();
        flipShown = true;
    }
}
function mouseexit(action){
    if (flipShown)
    {
        // fade in the info button
        if (fadeFlip.timer != null)
        {
            clearInterval (fadeFlip.timer);
            fadeFlip.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        fadeFlip.duration = 1000;
        fadeFlip.starttime = starttime;
        fadeFlip.firstElement = $(action);
        fadeFlip.timer = setInterval ("animateFlip();", 13);
        fadeFlip.from = fadeFlip.now;
        fadeFlip.to = 0.0;
        animateFlip();
        flipShown = false;
    }
}
function animateFlip(){
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-fadeFlip.starttime, 0, fadeFlip.duration);
        
    if (T >= fadeFlip.duration)
    {
        clearInterval (fadeFlip.timer);
        fadeFlip.timer = null;
        fadeFlip.now = fadeFlip.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / fadeFlip.duration));
        fadeFlip.now = computeNextFloat (fadeFlip.from, fadeFlip.to, ease);
    }
        
    fadeFlip.firstElement.style.opacity = fadeFlip.now;
}
function limit_3 (a, b, c){
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease){
    return from + (to - from) * ease;
}


function enterflip(event){
	$('fliprollie').style.display = 'block';
}

function exitflip(event){
	$('fliprollie').style.display = 'none';
}
